/***************************************************************************
 *   Copyright (C) 2004 by Reichert Bernard                                *
 *   valen16@trypill.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include <qthread.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <Imlib2.h>

//class for previews and taking screenshots
class FetchWindowThrd : public QThread
{
	public:
		//fetched window size
		int x;
		int y;
		int w;
		int h;
		int m_nTimeout;
	public:
	
		FetchWindowThrd():QThread()
		{
			x=0;
			y=0;
			w=0;
			h=0;
			m_nTimeout=0;
		}
		
		virtual void run()
		{
			sleep(m_nTimeout);
			getWindow();
		}
		
		bool getWindow()
		{
		
			//extracted from xkill source code
			Cursor cursor;		// cursor to use when selecting
			Window root;		// the current root
			Window retwin = None;	// the window that got selected
			int retbutton = -1;	// button used to select window
			int pressed = 0;	// count of number of buttons pressed
			
			//open display
			Display *dpy = XOpenDisplay(0);
			//get default screen
			int screen = DefaultScreen(dpy);
			
			root = RootWindow (dpy, screen);
			cursor = XCreateFontCursor (dpy, XC_draped_box);
			
			if (cursor == None) {
				return false;
			}
			#define MASK (ButtonPressMask | ButtonReleaseMask)
			//create a grab pointer
			if (XGrabPointer (dpy, root, False, MASK, GrabModeSync, GrabModeAsync, 
					None, cursor, CurrentTime) != GrabSuccess) {
				return false;
			}

			//wait until the user clicked the button
			while (retwin == None || pressed != 0) {
				XEvent event;
		
				XAllowEvents (dpy, SyncPointer, CurrentTime);
				XWindowEvent (dpy, root, MASK, &event);
				switch (event.type) {
				case ButtonPress:
					if (retwin == None) {
					retbutton = event.xbutton.button;
					retwin = ((event.xbutton.subwindow != None) ?
						event.xbutton.subwindow : root);
					}
					pressed++;
					continue;
				case ButtonRelease:
					if (pressed > 0) pressed--;
						continue;
				}
			}
			
			//release pointer
			XUngrabPointer (dpy, CurrentTime);
			//free cursor
			XFreeCursor (dpy, cursor);
			XSync (dpy, 0);
			//now get window attribes
			XWindowAttributes Attr;
			XGetWindowAttributes(dpy,retwin,&Attr);
			x = Attr.x;
			y = Attr.y;
			w = Attr.width;
			h = Attr.height;
			return true;
		}
};
