/***************************************************************************
 *   Copyright (C) 2004 by Reichert Bernard                                *
 *   valen16@trypill.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 

//needed includes 

//for threading support
#include <qthread.h>

//needed for qt object control
#include <qprogressbar.h>

//for image functions
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <Imlib2.h>

//needed datatypes
#include "FileItem.h"
#include <vector.h>
#include <qfile.h>

//class definition
 class GalleryThrd  : public QThread{
 	//private member vars
	private:
		//pointer to progress bar in Album widget
		QProgressBar *m_ctProgress;
		//string for output files (location, pattern,...
		QString m_strType,m_strLocation,m_strPattern,m_strTitle;
		//pointer to file list vector
		vector<FileItem*> *m_pvecFileList;
		//create thumbs?
		bool m_bThumbs;
		//blend logo?
		bool m_bLogo;
		//create album?
		bool m_bSite;
		//image for logo
		Imlib_Image m_imageLogo;
		//logo position (top,left,bottom,right,center,...)
		int m_nLogoPos;
		//logo file
		QString m_strLogo;

		
		//image size variables (original,copied,thumbs,...)
		//resize thumbnails to:
		int m_twidth;
		int m_theight;
		//resize large images to:
		int m_owidth;
		int m_oheight;
		//resize ratio:
		int m_resizeType;
		//size of the loadeed image
		int orig_height;
		int orig_width;
		//logo size
		uint m_logo_width;
		uint m_logo_height;
		
		//style name
		QString m_strStyle;
		//extension for file (jpeg =>jpg, ...)
		QString m_strExt;
		//files counter (imageXXXX.jpg)
		uint m_nCount;
	//public methods (set properties and run thread)
	public:
		//begins a new thread
		virtual void run();
		//begins creating the images, galleries, blending and so on
		void begin();
		//set booleans,strings and progressbar
		void setBools(bool bThumbs, bool bSite, bool bLogo);
		void setStrings(QString strType,QString strLocation,QString strPattern,QString strTitle,QString strLogo,QString strStyle);
		void setIntegers(int nLogoPos, int owidth, int oheight, int twidth, int theight, int resizeType);
		void setProgressBar(QProgressBar *ctProgress);
		void setFileList(vector<FileItem*> *pvecFileList);
		
		//recalculate image size for large images in gallery
		void recalcLarge();
		//reformat type ( jpeg => jpg)
		void reformatExt();
		//format number for image names
		QString formatNumber(int Number);
		
		//convert to thumbnail:
		void doThumbnail(Imlib_Image *imgresized,QString strNumber);
		
		//create logo:
		void doLogoBlending();
		
		//create website
		void doCreateWebsite(uint files);
		QStringList readConfig();
		
 };
