/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

/***************************************************************************
 *   Copyright (C) 2004 by Reichert Bernard                                *
 *   valen16@trypill.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


void ScreenshotWid::init()
{
	//create and positionate imagebutton
	m_imgButton = new ImageButton( this, "ImageButton" );
	m_imgButton->setGeometry( QRect( 15, 120, 430, 390 ));
	m_imgButton->setFlat(true);
	//connect button click event with onImageClicked
	connect(m_imgButton,SIGNAL(onMouseClick(int, int)),this,SLOT(onImageClicked(int, int)));
	emit onPreviewClicked();
	m_cross=new Cross;
	
	//init counter
	m_nCount = 0;
	
	//set location to users homedir
	m_txLocation->setText(QDir::homeDirPath());
	if(m_txLocation->text().at(m_txLocation->text().length()-1)!='/')
		m_txLocation->setText(m_txLocation->text()+'/');
}

void ScreenshotWid::destroy()
{
	//disconnect signals
	disconnect(m_imgButton,SIGNAL(onMouseClick(int, int)),this,SLOT(onImageClicked(int, int)));
	delete m_imgButton;
	delete m_cross;
}


void ScreenshotWid::onSetLocation()
{
	//pop-up a directory selection dialog
	QString strPath = QDir::homeDirPath();
	if(strPath.at(strPath.length()-1)!='/')
		strPath+='/';
	QString strFolder = QFileDialog::getExistingDirectory(strPath,
			this,
			"Choose a directory","",
			TRUE ,FALSE);
	//set location where the screenshot should be saved
	m_txLocation->setText(strFolder);
}

void ScreenshotWid::onPreviewClicked()
{
	//create thread and set thread properties
	m_screenThrd = new ScreenshotThrd();
	m_screenThrd->setSize(430,390);
	QString strPath = QDir::homeDirPath();
	if(strPath.at(strPath.length()-1)!='/')
		strPath+='/';
	m_screenThrd->setFile(strPath+"/.kphotoolscache.png");
	m_screenThrd->setTimeout(0);
	m_screenThrd->selectWindow(0,0,0,0);
	m_screenThrd->start();
	//create, connect and start timer
	m_pTimer = new QTimer(this, "TIMER");
	connect( m_pTimer, SIGNAL(timeout()), this, SLOT(onPreview()));
	m_pTimer->start(0);
	//disable button
	m_btPreview->setOn(false);
}

void ScreenshotWid::onPreview()
{
	//wait until the screen was captured completely
	m_screenThrd->wait();
	//delete thread
	delete m_screenThrd;
	//stop timer
	m_pTimer->stop();
	//disconnect time
	disconnect( m_pTimer, SIGNAL(timeout()), this, SLOT(onPreview()) );
	//delete timer
	delete m_pTimer;
	
	//load new image and show it in the windo
	QPixmap pix;
	QImage img;
	if(!img.load(QDir::homeDirPath()+"/.kphotoolscache.png")){}
	pix.convertFromImage(img);
	m_imgButton->setPixmap(pix);
	//enable button
	m_btPreview->setOn(true);
	setCross(-1,-1,false);
	setCross(-1,-1,false);
}

void ScreenshotWid::onScreenshotTaken()
{
	//wait until thread is finished
	m_screenThrd->wait();
	//delete capture thread
	delete m_screenThrd;
	//stop timer
	m_pTimer->stop();
	//disconnect it
	disconnect( m_pTimer, SIGNAL(timeout()), this, SLOT(onScreenshotTaken()) );
	//delete it
	delete m_pTimer;
	m_btScreenpart->setOn(true);
	m_btScreen->setOn(true);
	m_btPreview->setOn(true);
}


void ScreenshotWid::onCaptScreen()
{
	//create thread
	m_screenThrd = new ScreenshotThrd();
	//set output file
	m_screenThrd->setFile(m_txLocation->text()+"/"+m_txPattern->text()+formatNumber(m_nCount)+".png");
	//increment counter
	m_nCount++;
	//show updated counter
	m_lcdNumber->display(m_nCount);
	
	//set window which should be selected
	m_screenThrd->selectWindow(0,0,0,0);
	//set timeout before screenshot should be taken
	m_screenThrd->setTimeout(m_txTimeout->text().toInt());
	//start thread
	m_screenThrd->start();
	//create timer
	m_pTimer = new QTimer(this, "TIMER");
	//connect timer
	connect( m_pTimer, SIGNAL(timeout()), this, SLOT(onScreenshotTaken()) );
	//start timer
        m_pTimer->start( 100+m_txTimeout->text().toInt()*1000, TRUE );
	//disable buttons
	m_btScreenpart->setOn(false);
	m_btScreen->setOn(false);
	m_btPreview->setOn(false);
}


void ScreenshotWid::onSetCross()
{

}


void ScreenshotWid::onCaptPart()
{
	//create thread
	m_screenThrd = new ScreenshotThrd();
	//set output file
	m_screenThrd->setFile(m_txLocation->text()+"/"+m_txPattern->text()+formatNumber(m_nCount)+".png");
	//increment counter
	m_nCount++;
	//show updated counter
	m_lcdNumber->display(m_nCount);
	//set part size which should be captured
	m_screenThrd->selectWindow(
			(m_cross->m_x1<m_cross->m_x2)?m_cross->m_x1:m_cross->m_x2,
			(m_cross->m_x2>m_cross->m_x1)?m_cross->m_x2:m_cross->m_x1,
			(m_cross->m_y1<m_cross->m_y2)?m_cross->m_y1:m_cross->m_y2,
			(m_cross->m_y2>m_cross->m_y1)?m_cross->m_y2:m_cross->m_y1);
			
	//set timeout before screenshot should be taken
	m_screenThrd->setTimeout(m_txTimeout->text().toInt());
	//start thread
	m_screenThrd->start();
	//create timer
	m_pTimer = new QTimer(this, "TIMER");
	//connect timer
	connect( m_pTimer, SIGNAL(timeout()), this, SLOT(onScreenshotTaken()) );
	//start timer
        m_pTimer->start( 100+m_txTimeout->text().toInt()*1000, TRUE );
	//disable buttons
	m_btScreenpart->setOn(false);
	m_btScreen->setOn(false);
	m_btPreview->setOn(false);
}


void ScreenshotWid::onCaptWindow()
{
	m_fetchWindowThrd = new FetchWindowThrd();
	m_fetchWindowThrd->m_nTimeout = m_txTimeout->text().toInt();
	m_fetchWindowThrd->start();
	//create timer
	m_pTimer = new QTimer(this, "FETCHWINDOWTIME");
	//connect timer
	connect( m_pTimer, SIGNAL(timeout()), this, SLOT(onTimerEvent()) );
	//start timer
        m_pTimer->start( m_txTimeout->text().toInt()*1000);
}


void ScreenshotWid::onImageClicked( int x, int y)
{
	setCross(x,y,true);
}


void ScreenshotWid::onTimerEvent()
{
	if(m_fetchWindowThrd->running())
	{
		//start timer
        	m_pTimer->start( 100 );
	}else{
		//disconnect timer
		disconnect( m_pTimer, SIGNAL(timeout()), this, SLOT(onTimerEvent()) );
		//delete m_pTimer;
		onWindowFetched( m_fetchWindowThrd->x, m_fetchWindowThrd->y, m_fetchWindowThrd->w,m_fetchWindowThrd->h );
		delete m_fetchWindowThrd;
		
	}
	
}


void ScreenshotWid::setCross( int x, int y , bool redraw )
{
	//recreate original picture
	if(m_cross->m_isOne)
	{
		if(redraw){
		m_cross->m_x1o = m_cross->m_x1;
		m_cross->m_y1o = m_cross->m_y1;
		copyBlt ( (QPixmap*)m_imgButton->pixmap(), m_cross->m_x1o, 0, m_cross->m_pi1oa, 0, 0, 1, 390 );
		copyBlt ( (QPixmap*)m_imgButton->pixmap(), 0, m_cross->m_y1o, m_cross->m_pi2oa, 0, 0, 430, 1 );
		}
		
		//save next 2 lines
		copyBlt ( m_cross->m_pi1oa, 0, 0, (QPixmap*)m_imgButton->pixmap(), x, 0, 1, 390 );
		copyBlt ( m_cross->m_pi2oa, 0, 0, (QPixmap*)m_imgButton->pixmap(), 0, y, 430, 1 );
		
		m_cross->m_x1 = x;
		m_cross->m_y1 = y;
		copyBlt ( (QPixmap*)m_imgButton->pixmap(), m_cross->m_x1, 0, m_cross->m_pi1, 0, 0, 1, 390 );
		copyBlt ( (QPixmap*)m_imgButton->pixmap(), 0, m_cross->m_y1, m_cross->m_pi2, 0, 0, 430, 1 );
		m_cross->m_isOne = false;
	}else{
		if(redraw){
		m_cross->m_x2o = m_cross->m_x2;
		m_cross->m_y2o = m_cross->m_y2;
		copyBlt ( (QPixmap*)m_imgButton->pixmap(), m_cross->m_x2o, 0, m_cross->m_pi1ob, 0, 0, 1, 390 );
		copyBlt ( (QPixmap*)m_imgButton->pixmap(), 0, m_cross->m_y2o, m_cross->m_pi2ob, 0, 0, 430, 1 );
		}
		
		//save next 2 lines
		copyBlt ( m_cross->m_pi1ob, 0, 0, (QPixmap*)m_imgButton->pixmap(), x, 0, 1, 390 );
		copyBlt ( m_cross->m_pi2ob, 0, 0, (QPixmap*)m_imgButton->pixmap(), 0, y, 430, 1 );
		
		m_cross->m_x2 = x;
		m_cross->m_y2 = y;
		copyBlt ( (QPixmap*)m_imgButton->pixmap(), m_cross->m_x2, 0, m_cross->m_pi1, 0, 0, 1, 390 );
		copyBlt ( (QPixmap*)m_imgButton->pixmap(), 0, m_cross->m_y2, m_cross->m_pi2, 0, 0, 430, 1 );
		m_cross->m_isOne = true;
		
	}
	
	
	m_imgButton->update();
}




QString ScreenshotWid::formatNumber( int n )
{
	QString strNumber;
	if(n<10)
	{
		strNumber = "000"+QString::number(n,10);
	}else if(n<100)
	{
		strNumber = "00"+QString::number(n,10);
	}
	else if(n<1000)
	{
		strNumber = "0"+QString::number(n,10);
	}
	return strNumber;
}


void ScreenshotWid::onWindowFetched( int x, int y, int w, int h )
{
	//create thread
	m_screenThrd = new ScreenshotThrd();
	//set output file
	m_screenThrd->setFile(m_txLocation->text()+"/"+m_txPattern->text()+formatNumber(m_nCount)+".png");
	m_screenThrd->setCompleteWindow(true);
	//increment counter
	m_nCount++;
	//show updated counter
	m_lcdNumber->display(m_nCount);
	//set part size which should be captured
	m_screenThrd->selectWindow(x,w,y,h);
			
	//set timeout before screenshot should be taken
	m_screenThrd->setTimeout(0);
	//start thread
	m_screenThrd->start();
	//create timer
	m_pTimer = new QTimer(this, "TIMER");
	//connect timer
	connect( m_pTimer, SIGNAL(timeout()), this, SLOT(onScreenshotTaken()));
	//start timer
        m_pTimer->start( 10 , TRUE );
}
